<template>
  <Row class="investor-note-list">
    <stock-list-page :search-columns="searchColumns"
                     :table-columns="tableColumns"
                     :table-data="tableData"
                     :total-data-amount="totalData"
                     :page-size-options="[30]"
                     @search="getNotesAction">
      <div class="literal-div-btn create-btn" @click="redirectAction('create')">New Note</div>
    </stock-list-page>
  </Row>
</template>

<script>
import StockListPage from '../../../components/StockListPage'
import { columns } from '../../../helpers/list';
import { validators as api } from '../../../configs/request-validator/note';

const actions = {
  async getNotesAction(filter) {
    const requestData = {
      userId: null,
      pageAt: filter.pageAt || 1,
      pageSize: filter.pageSize || 30,
    };
    this.$conditionMutator(requestData, filter);

    try {
      const { data: { notes, total } } = await this.$api(api.AccessAllNotesResult, requestData);
      this.tableData = notes;
      this.totalData = total;
    } catch (error) {
      this.$apiErrorHandler(error);
    }
  },
  redirectAction(type, noteId) {
    let params = { type };
    let query = undefined;
    switch (type) {
      case 'view':
      case 'edit':
        params.id = noteId.toString();
        break;
      case 'create':
        params.id = '-1';
        break;
    }
    this.$redirectTo('investor-note-id-type', params, query);
  }
};

export default {
  name: 'index',
  components: { StockListPage },
  data() {
    return {
      searchColumns: [
        {value: 'id', label: 'ID'},
        {value: 'title', label: 'Title'},
        {value: 'content', label: 'Content'},
        {value: 'user.id', label: 'Author ID'},
        {value: 'user.name', label: 'Author Name'},
        {value: 'user.email', label: 'Author Email'},
      ],
      tableColumns: [
        // columns.selection,
        columns.index,
        columns.id,
        { title: 'Title', key: 'title' },
        {
          title: 'Create At',
          width: 150,
          align: 'center',
          fixed: 'right',
          render: (h, param) => {
            const timestamp = param.row['timestamp'];
            const localeDateString = (new Date(timestamp)).toLocaleDateString();
            return h('span', {}, localeDateString);
          }
        },
        {
          title: 'Actions',
          width: 150,
          align: 'center',
          fixed: 'right',
          render: (h, param) => {
            const vue = this;
            const noteId = param.row['id'];
            return h('div', [
              h('div', {
                class: 'note-view-btn div-btn inline-block',
                on: { click: () => { vue.redirectAction('view', noteId) } }
                },
                [
                  h('Icon', { props: { type: 'md-eye' } })
                ]),
              h('div', {
                class: 'note-edit-btn div-btn inline-block',
                on: { click: () => { vue.redirectAction('edit', noteId) } }
                },
                [
                  h('Icon', { props: { type: 'md-create' } })
                ]),
            ]);
          }
        }
      ],
      tableData: undefined,
      totalData: 0,
    };
  },
  methods: {
    ...actions,
  },
  mounted() {
    this.$displayBodyBlock(false);
  },
  async asyncData({ app }) {
    let tableData = undefined;
    let totalData = 0;

    // request
    const getNoteRequest = {
      userId: null,
      pageAt: 1,
      pageSize: 30,
    };
    app.$conditionMutator(getNoteRequest, {});

    // invoke api
    try {
      const allResponse = await Promise.all([
        app.$api(api.AccessAllNotesResult, getNoteRequest, undefined, false),
      ]);
      tableData = allResponse[0]['data']['notes'];
      totalData = allResponse[0]['data']['total'];
    } catch (error) {
      app.$apiErrorHandler(error);
    }
    return { tableData, totalData };
  }
}
</script>

<style lang="scss">
  @import "../../../assets/css/mixin";

  .investor-note-list {
    .note-view-btn {
      margin-left: 10px;
      @include circle-div-btn(32);
    }
    .note-edit-btn {
      margin-left: 10px;
      @include circle-div-btn(32);
    }
  }
</style>
